@make(ais)
@aiInfo(topic=<Declaring a fixed point type that occupies one word>,
number=[AI-00147/05],
classcode=[ra],
statuscode=[WJ],
mainref=[03.05.09@\(18)],
date=[87-08-06])
@aiHeading()
@begin(history)
@begin(toplines)
@mainref()
!class ramification 84-01-10
!status approved by WG9/AJPO 87-07-30
@end(toplines)
!status approved by Director, AJPO 87-07-30
!status approved by Ada Board 87-07-30
!status approved by WG9 87-05-29
!status panel/committee-approved 87-01-19 (reviewed)
!status panel/committee-approved (6-0-0) 86-11-14 (pending editorial review)
!status work-item 86-10-05
!status received 84-01-10
@references[!references @CommentNum[83-00232]83-00232]
@topic{!topic @value(aitopic)}
@end(history)

@subheading[!summary 86-10-05]

A fixed point type that occupies a full word can be declared as:
@begin(example)
DEL : @key[constant] := 1.0/2@exp()(WORD_@|LENGTH - 1);
@key[type] FRACTION @key[is] @key[delta] DEL @key[range] -1.0 .. 1.0 - DEL;
@end(example)
@subheading[!question 86-10-05]

3.5.9(18) gives the following declarations as the way to declare a fixed
point type that fully occupies one word:
@begin(example)
DEL : @key[constant] := 1.0/2@exp()(WORD_@|LENGTH - 1);
@key[type] FRACTION @key[is] @key[delta] DEL @key[range] -1.0 .. 1.0 - DEL;
@end(example)
It does not seem that this type declaration is correct, since the base type
must be chosen so -1.0 can be represented as a model number.  Shouldn't the
declaration be as follows?
@begin(example)
@key[type] FRACTION @key[is] @key[delta] DEL @key[range] -1.0 + DEL .. 1.0 - DEL;
@end(example)
@subheading[!response 87-06-04]

The example as written is correct.  3.5.9(6) requires that the mantissa
length be chosen
@begin(quotation)
as the smallest integer number for which each bound of the specified
range is either a model number or lies at most @i[small] distant from
a model number.
@end(quotation)
For the type FRACTION, @i[small] is equal to DEL.  The smallest model number for
type FRACTION is -1.0 + DEL, which does lie at most @i[small] from the lower
bound, -1.0, when the mantissa length is WORD_@|LENGTH - 1.  (Note that -1.0
itself is not a model number.)

